import { jsx as d, jsxs as f, Fragment as L } from "react/jsx-runtime";
import i from "clsx";
import z, { useState as U, useEffect as H } from "react";
/*!
  @versini/ui-bubble v3.0.2
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_BUBBLE__ || (window.__VERSINI_UI_BUBBLE__ = {
    version: "3.0.2",
    buildTime: "01/04/2025 01:33 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const O = "av-bubble", C = "av-button", y = "icon", M = "button", I = "link", j = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: l
}) => {
  const o = "max-h-8 py-0 px-2", g = "max-h-9 py-1 px-3", s = "max-h-12 py-2 px-4";
  switch (e) {
    case M:
    case I:
      return i({
        [o]: r === "small",
        [g]: r === "medium",
        [s]: r === "large"
      });
    case y:
      return i("inline-flex items-center", {
        "justify-center": l === "center",
        "justify-start": l === "left",
        "justify-end": l === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-2": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-3": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4": r === "large" && (t || a)
      });
  }
}, P = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a
}) => {
  const l = "text-sm font-medium", o = "text-base font-medium", g = "text-lg font-medium";
  switch (e) {
    case M:
    case I:
      return i({
        "text-center": e === I,
        [l]: r === "small",
        [o]: r === "medium",
        [g]: r === "large"
      });
    case y:
      return i({
        [l]: r === "small" && (t || a),
        [o]: r === "medium" && (t || a),
        [g]: r === "large" && (t || a)
      });
  }
}, W = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a
}) => {
  if (r)
    return "not-prose";
  if (a === "primary")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "dark" || e === "system",
      "text-copy-lighter": e === "light" || e === "alt-system",
      "dark:text-copy-lighter": e === "system",
      "dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "light" || e === "system",
      "text-copy-lighter": e === "dark" || e === "alt-system",
      "dark:text-copy-lighter": e === "alt-system",
      "dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return i("not-prose", {
      truncate: !t,
      "text-copy-light": e === "dark" || e === "system",
      "text-copy-lighter": e === "light" || e === "alt-system",
      "dark:text-copy-lighter": e === "system",
      "dark:text-copy-light": e === "alt-system"
    });
  if (a === "selected")
    return i("not-prose text-copy-lighter", {
      truncate: !t
    });
}, A = ({
  mode: e,
  noBackground: r,
  variant: t
}) => {
  if (!r) {
    if (t === "primary")
      return i({
        "bg-action-dark": e === "dark",
        "bg-action-light": e === "light",
        "bg-action-dark dark:bg-action-light": e === "system",
        "bg-action-light dark:bg-action-dark": e === "alt-system"
      });
    if (t === "secondary")
      return i({
        "bg-action-dark": e === "light",
        "bg-action-light": e === "dark",
        "bg-action-dark dark:bg-action-light": e === "alt-system",
        "bg-action-light dark:bg-action-dark": e === "system"
      });
    if (t === "danger")
      return i({
        "bg-action-danger-dark": e === "dark",
        "bg-action-danger-light": e === "light",
        "bg-action-danger-dark dark:bg-action-danger-light": e === "system",
        "bg-action-danger-light dark:bg-action-danger-dark": e === "alt-system"
      });
    if (t === "selected")
      return "bg-action-selected-dark";
  }
}, G = ({
  radius: e
}) => i({
  "rounded-full": e === "large",
  "rounded-md": e === "medium",
  "rounded-sm": e === "small"
}), q = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return i("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
  if (t === "selected")
    return "hover:text-copy-light-hover hover:bg-action-selected-dark-hover";
}, D = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return i("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return i("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
  if (t === "selected")
    return "active:text-copy-lighter-active active:bg-action-selected-dark-active";
}, F = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return i("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return i("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return i("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
  if (t === "selected")
    return "border border-border-selected-dark";
}, J = ({
  focusMode: e
}) => i("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), V = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: l,
  disabled: o,
  fullWidth: g,
  size: s,
  noBorder: h,
  labelRight: m,
  labelLeft: b,
  noBackground: u,
  variant: n,
  noTruncate: c,
  align: v,
  radius: p
}) => (n || (n = "primary"), t ? i(C, r) : i(
  C,
  W({
    mode: a,
    variant: n,
    noBackground: u,
    noTruncate: c
  }),
  A({ mode: a, noBackground: u, variant: n }),
  G({ radius: p }),
  j({
    type: e,
    size: s,
    labelRight: m,
    labelLeft: b,
    align: v
  }),
  P({ type: e, size: s, labelRight: m, labelLeft: b }),
  F({ mode: a, variant: n, noBorder: h }),
  J({ focusMode: l }),
  q({ mode: a, variant: n, disabled: o }),
  D({ mode: a, variant: n, disabled: o }),
  {
    "w-full": g,
    "disabled:cursor-not-allowed disabled:opacity-50": o
  },
  r
)), K = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, T = z.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...l } = e;
  return /* @__PURE__ */ d(
    "button",
    {
      ref: r,
      onClick: (o) => {
        K(o, a, t);
      },
      ...l
    }
  );
});
T.displayName = "BaseButton";
const E = z.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: l = !1,
    className: o,
    type: g = "button",
    raw: s = !1,
    noBorder: h = !1,
    "aria-label": m,
    label: b,
    size: u = "medium",
    labelRight: n,
    labelLeft: c,
    noBackground: v = !1,
    align: p = "center",
    radius: k = "large",
    variant: x = "primary",
    ...w
  }, B) => {
    const _ = V({
      type: y,
      mode: t,
      focusMode: a,
      fullWidth: l,
      disabled: r,
      raw: s,
      className: o,
      noBorder: h,
      size: u,
      labelRight: n,
      labelLeft: c,
      noBackground: v,
      align: p,
      radius: k,
      variant: x
    }), N = i({
      "text-copy-accent-dark": t === "light" && !s,
      "text-copy-light": t === "dark" && !s,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !s,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !s
    });
    return /* @__PURE__ */ f(
      T,
      {
        ref: B,
        className: _,
        disabled: r,
        type: g,
        "aria-label": m || b,
        ...w,
        children: [
          c && /* @__PURE__ */ d("span", { className: "pr-2", children: c }),
          /* @__PURE__ */ d("div", { className: N, children: e }),
          n && /* @__PURE__ */ d("span", { className: "pl-2", children: n })
        ]
      }
    );
  }
);
E.displayName = "ButtonIcon";
/*!
  @versini/ui-button v4.0.2
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "4.0.2",
    buildTime: "01/04/2025 01:33 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = z.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: l = !1,
    className: o,
    type: g = "button",
    raw: s = !1,
    noBorder: h = !1,
    "aria-label": m,
    label: b,
    size: u = "medium",
    labelRight: n,
    labelLeft: c,
    noBackground: v = !1,
    align: p = "center",
    active: k = !1,
    radius: x = "large",
    ...w
  }, B) => {
    const _ = V({
      type: y,
      mode: t,
      focusMode: a,
      fullWidth: l,
      disabled: r,
      raw: s,
      className: o,
      noBorder: h,
      size: u,
      labelRight: n,
      labelLeft: c,
      noBackground: v,
      align: p,
      radius: x
    }), N = i({
      "text-copy-accent-dark": t === "light" && !s,
      "text-copy-light": t === "dark" && !s,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !s,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !s
    }), R = k ? i(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ d("div", { className: R, children: /* @__PURE__ */ f(
      T,
      {
        ref: B,
        className: _,
        disabled: r,
        type: g,
        "aria-label": m || b,
        ...w,
        children: [
          c && /* @__PURE__ */ d("span", { className: "pr-2", children: c }),
          /* @__PURE__ */ d("div", { className: N, children: e }),
          n && /* @__PURE__ */ d("span", { className: "pl-2", children: n })
        ]
      }
    ) });
  }
);
Q.displayName = "ButtonSort";
const S = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: l,
  size: o,
  title: g,
  semantic: s = !1,
  ...h
}) => {
  const m = i(o, a);
  return /* @__PURE__ */ f(L, { children: [
    /* @__PURE__ */ d(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: t || l,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !s,
        focusable: !1,
        ...h,
        children: e
      }
    ),
    g && s && /* @__PURE__ */ d("span", { className: "sr-only", children: g })
  ] });
};
/*!
  @versini/ui-svgicon v4.0.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "4.0.0",
    buildTime: "01/04/2025 01:33 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const X = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: a,
  ...l
}) => /* @__PURE__ */ f(
  S,
  {
    defaultViewBox: "0 0 448 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copied",
    ...l,
    children: [
      /* @__PURE__ */ d(
        "path",
        {
          opacity: "0.4",
          d: "M64 32C28.7 32 0 60.7 0 96V416c0 35.3 28.7 64 64 64H384c35.3 0 64-28.7 64-64V96c0-35.3-28.7-64-64-64H64zM337 209L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0s9.4 24.6 0 33.9z"
        }
      ),
      /* @__PURE__ */ d("path", { d: "M337 175c9.4 9.4 9.4 24.6 0 33.9L209 337c-9.4 9.4-24.6 9.4-33.9 0l-64-64c-9.4-9.4-9.4-24.6 0-33.9s24.6-9.4 33.9 0l47 47L303 175c9.4-9.4 24.6-9.4 33.9 0z" })
    ]
  }
), Y = ({
  className: e,
  viewBox: r,
  title: t,
  monotone: a,
  ...l
}) => /* @__PURE__ */ d(
  S,
  {
    defaultViewBox: "0 0 512 512",
    size: "size-5",
    viewBox: r,
    className: e,
    title: t || "Copy",
    ...l,
    children: /* @__PURE__ */ d("path", { d: "M64 464H288c8.8 0 16-7.2 16-16V384h48v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V224c0-35.3 28.7-64 64-64h64v48H64c-8.8 0-16 7.2-16 16V448c0 8.8 7.2 16 16 16zM224 304H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H224c-8.8 0-16 7.2-16 16V288c0 8.8 7.2 16 16 16zm-64-16V64c0-35.3 28.7-64 64-64H448c35.3 0 64 28.7 64 64V288c0 35.3-28.7 64-64 64H224c-35.3 0-64-28.7-64-64z" })
  }
);
/*!
  @versini/ui-icons v4.1.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "4.1.0",
    buildTime: "01/04/2025 01:33 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Z = () => "p-4 max-w-xs sm:max-w-md md:max-w-2xl", $ = ({ kind: e }) => i({
  "bg-surface-lighter dark:bg-surface-dark": e === "left",
  "bg-surface-accent": e === "right"
}), ee = ({ kind: e }) => i(
  "prose prose-dark dark:prose-lighter prose-p:my-3 prose-blockquote:my-3 prose-ol:my-3 prose-ul:my-3 prose-ul:prose-li:marker:text-black",
  {
    "text-copy-lighter": e === "right"
  }
), te = ({ kind: e }) => i("rounded-b-xl", {
  "rounded-tr-xl": e === "left",
  "rounded-tl-xl": e === "right"
}), re = ({
  kind: e,
  className: r
}) => {
  const t = i(
    O,
    "flex items-start",
    {
      "flex-row-reverse": e === "right"
    },
    r
  ), a = i(
    "flex flex-col empty:hidden",
    Z(),
    ee({ kind: e }),
    $({ kind: e }),
    te({ kind: e })
  ), l = "pr-2 pt-1 text-end text-xs text-copy-light", o = i("flex flex-col-reverse gap-2 sm:flex-row", {
    "ml-2": e === "left",
    "mr-2": e === "right"
  });
  return {
    wrapper: t,
    main: a,
    footer: l,
    copyButton: o
  };
}, le = ({
  children: e,
  kind: r = "left",
  className: t,
  footer: a,
  rawFooter: l,
  copyToClipboard: o,
  copyToClipboardFocusMode: g = "system",
  copyToClipboardMode: s = "system"
}) => {
  const [h, m] = U(!1), b = re({ kind: r, className: t }), u = !!o && (typeof o == "function" || typeof o == "string" || typeof e == "string"), n = () => {
    m(!0), typeof o == "function" ? o(e) : typeof o == "string" ? navigator.clipboard.writeText(o) : typeof e == "string" && navigator.clipboard.writeText(e);
  };
  return H(() => {
    let c;
    return h && (c = window.setTimeout(() => {
      m(!1);
    }, 3e3)), () => {
      clearTimeout(c);
    };
  }, [h]), /* @__PURE__ */ f("div", { className: b.wrapper, children: [
    /* @__PURE__ */ f("div", { children: [
      /* @__PURE__ */ d("div", { className: b.main, children: e }),
      a && Object.keys(a).map((c) => a[c] ? /* @__PURE__ */ d("div", { className: "prose-p:m-0", children: /* @__PURE__ */ f("p", { className: b.footer, children: [
        c,
        ": ",
        a[c]
      ] }) }, `-${c}`) : null),
      l && l
    ] }),
    u && /* @__PURE__ */ d("div", { className: b.copyButton, children: /* @__PURE__ */ d(
      E,
      {
        noBorder: !0,
        noBackground: !0,
        size: "small",
        mode: s,
        focusMode: g,
        label: h ? "Copied to clipboard" : "Copy to clipboard",
        onClick: n,
        disabled: h,
        children: h ? /* @__PURE__ */ d(X, { size: "size-3" }) : /* @__PURE__ */ d(Y, { size: "size-3" })
      }
    ) })
  ] });
};
export {
  O as BUBBLE_CLASSNAME,
  le as Bubble
};
